#pragma once

#include "DXUTcamera.h"

class Camera : public CFirstPersonCamera
{
public:
	Camera(void);
	~Camera(void);

	void FrameMove( float fElapsedTime );	
    void UpdateFrustum();
	bool FrustumSphereCheck(D3DXVECTOR3 &vCenter, float fRadius);
	bool FrustumCubeCheck( D3DXVECTOR3 &vCenter, float fSize );
	bool FrustumCubeCheck( D3DXVECTOR3 &vMin, D3DXVECTOR3 &vMax );	

	void SetPosition( D3DXVECTOR3 v )	{ m_vEye = v; }
	const D3DXVECTOR3* GetEyePt() const { return (D3DXVECTOR3*)&m_vEye; }
	
	const float GetYawAngle()			{ return m_fCameraYawAngle; }
	const float GetPitchAngle()			{ return m_fCameraPitchAngle; }
	D3DXVECTOR3 *GetDirection()			{ return &(m_vLookAt - m_vEye); }
	const float GetFov()				{ return m_fFOV; }
	const float GetAspect()				{ return m_fAspect; }		
	
protected:
	// 6 planes to store our view frustum
	D3DXPLANE mPlanes[6];
};
