#include "dxut.h"
#include "Ray.h"

Ray::Ray() 
{ 
	mOrigin = mDirection = D3DXVECTOR3(0.0f, 0.0f, 0.0f); 
}

Ray::Ray(D3DXVECTOR3 o, D3DXVECTOR3 d)
{
	mOrigin = o;
	mDirection = d;
}


float Ray::Intersect(BoundingBox bbox)
{
	if(D3DXBoxBoundProbe(&bbox.min, &bbox.max, &mOrigin, &mDirection))
		return D3DXVec3Length(&(((bbox.min + bbox.max) / 2.0f) - mOrigin));
	else return -1.0f;
}

float Ray::Intersect(LPD3DXMESH mesh)
{
	if(mesh == NULL)return -1.0f;

	// Collect only the closest intersection
	BOOL hit;
	DWORD dwFace;
	float hitU, hitV, dist;
	D3DXIntersect(mesh, &mOrigin, &mDirection, &hit, &dwFace, &hitU, &hitV, &dist, NULL, NULL);

	if(hit) return dist;
	else return -1.0f;
}